;yacy_admin.nsi
;--------
;(C) 2007 by Matthias Soehnholz

!define PRODUCT_NAME "YaCy-Admin"
!define PRODUCT_VERSION "@RELEASE_VERSION@"
Name ${PRODUCT_NAME}

OutFile "@RELEASE_FILE_NAME@.exe"
InstallDir $PROGRAMFILES\YaCy-Admin

SetCompress auto
SetCompressor lzma

InstType /CUSTOMSTRING=Custom

InstType "Normal"
InstType "Full"

; The text to prompt the user to enter a directory
ComponentText "This will install ${PRODUCT_NAME} ${PRODUCT_VERSION} on your computer. Select which optional things you want to be installed."
; The text to prompt the user to enter a directory
DirText "Choose a directory to install into:"

LicenseText "You must agree to this license to install YaCy"
LicenseData "..\LICENSE"

Section "Binaries (required)"
	SectionIn 1 2 RO
	SetOutPath $INSTDIR
	#main files
	File "..\AUTHORS"
	File "..\LICENSE"
	File "..\README"
	File "..\start.bat"
	File "..\Soap-TODO"
	File "..\TODO"
	File "..\yacyAdmin.exe"
	File "..\yacyAdmin.jar"
	
	#lib
	SetOutPath "$INSTDIR\lib"
	File /r /x .svn /x sunos /x linux "..\lib\*"

	#ressources
	SetOutPath "$INSTDIR\ressources"
	File /r /x .svn "..\ressources\*"

	#classes
	SetOutPath "$INSTDIR\classes"
	File /r /x .svn "..\classes\*"
	
	SetOutPath $INSTDIR
	
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\YaCy_Admin" "DisplayName" "${PRODUCT_NAME}"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\YaCy_Admin" "UninstallString" '"$INSTDIR\uninstall.exe"'
	WriteUninstaller "uninstall.exe"

SectionEnd

Section "Development"
	SectionIn 2
	SetOutPath $INSTDIR\source

	File /r /x .svn "..\source\*"

	SetOutPath $INSTDIR
	File "..\.classpath"
	File "..\.project"
	File "..\build.xml"
	File "..\client-config.wsdd"
	File "..\MANIFEST"

SectionEnd

Section "Shortcuts in the Start Menu"
	SectionIn 1 2
	SetOutPath "$INSTDIR"
	CreateDirectory "$SMPROGRAMS\YaCy-Admin"
	CreateShortCut "$SMPROGRAMS\YaCy-Admin\yacyAdmin.lnk" "$INSTDIR\yacyAdmin.exe"
	CreateShortCut "$DESKTOP\yacyAdmin.lnk" "$INSTDIR\yacyAdmin.exe"
	
	CreateShortCut "$SMPROGRAMS\YaCy-Admin\start YACY.pif" "$INSTDIR\start.bat" "" "$INSTDIR\ressources\favicon.ico"
	CreateShortCut "$SMPROGRAMS\YaCy-Admin\Readme.lnk" "$INSTDIR\LICENSE"
	CreateShortCut "$SMPROGRAMS\YaCy-Admin\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
SectionEnd

;Section "YaCy-Admin on the Desktop"
;	SetOutPath "$INSTDIR"
;	CreateShortCut "$DESKTOP\YaCy-Admin.pif" "$INSTDIR\start.bat" "" "$INSTDIR\ressources\favicon.ico"
;SectionEnd

Section "Uninstall"
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\YaCy_Admin"
	MessageBox MB_YESNO|MB_ICONQUESTION "Do you want to keep the Connection-Settings (i.e. if you want to reinstall later)?" IDYES keepdata

	#delete all
	DeleteRegKey HKCU "Software\JavaSoft\Prefs\yacy-admin"

	#or jump to this
	keepdata:

  	Delete "$DESKTOP\yacyAdmin.lnk"
  	Delete "$SMPROGRAMS\YaCy-Admin\yacyAdmin.lnk"
;	Delete "$DESKTOP\YaCy-Admin.pif"
	RMDir /r "$SMPROGRAMS\YaCy-Admin"
	RMDir /r "$INSTDIR"
SectionEnd
