/* 
 * Autor: Franz Brauße
 * License: GPL v2 
 */

package plugins;

import general.Config;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.rmi.RemoteException;

import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;

import views.PanelPlugin;
import yacy.Peer;
import yacy.exceptions.PBlacklistExistsEx;


public class Blacklist extends JPanel implements views.PanelPlugin {
	
	private static final long	serialVersionUID	= 1L;

	private JTabbedPane jTabbedPane = null;
	private JPanel 		jPanel 		= null;
	private JPanel 		jPanel1 	= null;
	private JPanel 		jPanel2 	= null;
	private JComboBox 	jComboBox 	= null;
	private JPanel 		jPanel3 	= null;
	private JPanel 		jPanel4 	= null;
	private JTextField 	jTextField 	= null;
	private JButton 	jButton 	= null;
	private JTextField 	jTextField1 = null;
	private JButton 	jButton1 	= null;
	private JButton 	jButton2 	= null;
	private JLabel 		jLabel11 	= null;
	private JLabel 		jLabel12 	= null;
	private JPanel 		jPanel5 	= null;
	private JLabel 		jLabel 		= null;
	private JCheckBox 	jCheckBox 	= null;
	private JCheckBox 	jCheckBox1 	= null;
	private JCheckBox 	jCheckBox2 	= null;
	private JCheckBox 	jCheckBox3 	= null;
	private JPanel 		jPanel6 	= null;
	private JLabel 		jLabel13 	= null;
	private JTextField 	jTextField2 = null;
	private JButton 	jButton3 	= null;
	private JLabel 		jLabel14 	= null;
	private JTextField 	jTextField3 = null;
	private JButton 	jButton4 	= null;
	private JLabel 		jLabel15 	= null;
	private JTextField 	jTextField4 = null;
	private JButton 	jButton5 	= null;
	private JLabel 		jLabel16 	= null;
	private JTextField 	jTextField5 = null;
	private JButton 	jButton6 	= null;
	private JLabel 		jLabel17 	= null;
	private JTextField 	jTextField6 = null;
	private JLabel 		jLabel18 	= null;
	private JButton 	jButton7 	= null;
	private JPopupMenu	jPopupMenu 	= null;
	private JDialog 	jDialog 	= null;  //  @jve:decl-index=0:visual-constraint="66,485"
	private JPanel 		jContentPane = null;
	private JLabel 		jLabel1 	= null;
	private JLabel 		jLabel2 	= null;
	private JLabel 		jLabel3 	= null;
	private JPanel 		jPanel7 	= null;
	private JButton 	jButton8 	= null;
	private JButton 	jButton9 	= null;
	private JScrollPane jScrollPane = null;
	private JList 		jList 		= null;
	private DefaultListModel list 	= null;
	
	private Peer 	peer = null;
	private Config	cfg  = null;
	private static final String PluginName 		= "Blacklist";
	private static final String PluginVersion 	= "0.1";
	
	public final 	String 	getDescription() 		{ return PluginName; }
	public final	String 	getVersion() 			{ return PluginVersion; }
	public final	String 	getMenuPath() 			{ return PanelPlugin.ADMIN; }
	public 			int 	getUpdateDelay() 		{ return 0; }
	public			int		getNeededYacyRevision() { return 2841; }
	public 			void 	doUpdate() 				{  }
	
	public ImageIcon getMenuIcon() { return new ImageIcon(); }
	public String	getMenuToolTip() { return ""; }
	
	public void init(Peer thePeer, Config config) {
		this.peer = thePeer;
		this.cfg = config;
		new Thread() { public void run() {
			try {
				for (String s : peer.getBlacklists())
					jComboBox.addItem(s);
			} catch (RemoteException e) { cfg.log(e); }
		} }.start();
	}
	
	private boolean isEntryConform(String entry, String engine) throws Exception {
		if (engine.equals(Peer.BLACKLIST_ENGINE_YACY)) {
			String domain = (entry.indexOf('/') == -1)
					? (entry)
					: (entry.substring(0, entry.indexOf('/') - 1));
			
			int wildcards = 0;
			for (int i=0; i<domain.length(); i++)
				wildcards += domain.charAt(i) == ('*') ? (1) : (0);
			if (wildcards > 1) return false;
			
			// TODO: more checks
			return true;
		} else {
			// FIXME: throw an own exception instead
			throw new Exception("Engine \"" + engine + "\" not supported.");
		}
	}
	
	public Blacklist() {
		super();
		initialize();
	}
	
	private void initialize() {
		this.setSize(414, 440);
		this.setLayout(new BorderLayout());
		this.add(getJTabbedPane(), BorderLayout.CENTER);
		this.add(getJPanel2(), BorderLayout.NORTH);
		if (list != null)
			list.clear();
	}
	
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.addTab("Einträge", null, getJPanel(), null);
			jTabbedPane.addTab("Einstellungen", null, getJPanel1(), null);
		}
		return jTabbedPane;
	}
	
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new BorderLayout());
			jPanel.add(getJPanel3(), BorderLayout.CENTER);
		}
		return jPanel;
	}
	
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(new BorderLayout());
			jPanel1.add(getJPanel5(), BorderLayout.NORTH);
			jPanel1.add(getJPanel62(), BorderLayout.CENTER);
		}
		return jPanel1;
	}
	
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			GridBagConstraints gridBagConstraints39 = new GridBagConstraints();
			gridBagConstraints39.gridx = 2;
			gridBagConstraints39.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints39.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints39.gridy = 1;
			GridBagConstraints gridBagConstraints38 = new GridBagConstraints();
			gridBagConstraints38.gridx = 0;
			gridBagConstraints38.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints38.gridy = 0;
			jLabel18 = new JLabel();
			jLabel18.setText("Blacklist wählen:");
			GridBagConstraints gridBagConstraints37 = new GridBagConstraints();
			gridBagConstraints37.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints37.gridy = 1;
			gridBagConstraints37.weightx = 1.0;
			gridBagConstraints37.insets = new Insets(5, 5, 5, 0);
			gridBagConstraints37.gridwidth = 2;
			gridBagConstraints37.gridx = 0;
			GridBagConstraints gridBagConstraints36 = new GridBagConstraints();
			gridBagConstraints36.gridy = 0;
			gridBagConstraints36.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints36.gridx = 2;
			GridBagConstraints gridBagConstraints35 = new GridBagConstraints();
			gridBagConstraints35.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints35.gridx = 1;
			gridBagConstraints35.gridy = 0;
			gridBagConstraints35.weightx = 1.0;
			jPanel2 = new JPanel();
			jPanel2.setLayout(new GridBagLayout());
			jPanel2.setPreferredSize(new Dimension(0, 70));
			jPanel2.add(getJComboBox(), gridBagConstraints35);
			jPanel2.add(getJButton2(), gridBagConstraints36);
			jPanel2.add(getJTextField6(), gridBagConstraints37);
			jPanel2.add(jLabel18, gridBagConstraints38);
			jPanel2.add(getJButton7(), gridBagConstraints39);
		}
		return jPanel2;
	}
	
	private JComboBox getJComboBox() {
		if (jComboBox == null) {
			jComboBox = new JComboBox();
			jComboBox.setPreferredSize(new Dimension(32, 19));
			jComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					list.clear();
					if (jComboBox.getSelectedItem() == null) return;
					try {
						String b = jComboBox.getSelectedItem().toString();
						if (peer.getBlacklistsContents(true).get(b) != null)
							for (String d :	peer.getBlacklistsContents(false).get(b))
								list.addElement(d);
						for (String d : peer.getBlacklistAttributes(jComboBox.getSelectedItem().toString())) {
							if (d.equals("crawler")) jCheckBox.setSelected(true);
							if (d.equals("proxy")) jCheckBox1.setSelected(true);
							if (d.equals("dht")) jCheckBox2.setSelected(true);
							if (d.equals("search")) jCheckBox3.setSelected(true);
						}
					} catch (RemoteException ee) { cfg.log(ee); }
				}
			});
		}
		return jComboBox;
	}
	
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.fill = GridBagConstraints.BOTH;
			gridBagConstraints17.gridy = 0;
			gridBagConstraints17.weightx = 1.0;
			gridBagConstraints17.weighty = 1.0;
			gridBagConstraints17.gridwidth = 3;
			gridBagConstraints17.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints17.gridx = 0;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.gridx = 0;
			gridBagConstraints31.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints31.gridy = 4;
			jLabel12 = new JLabel();
			jLabel12.setText("Filter:");
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 0;
			gridBagConstraints21.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints21.gridy = 3;
			jLabel11 = new JLabel();
			jLabel11.setText("Filter:");
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = 2;
			gridBagConstraints14.insets = new Insets(0, 5, 5, 5);
			gridBagConstraints14.gridy = 4;
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints6.gridx = 2;
			gridBagConstraints6.gridy = 3;
			gridBagConstraints6.insets = new Insets(0, 5, 5, 5);
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.gridy = 4;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.insets = new Insets(5, 5, 5, 5);
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 3;
			gridBagConstraints.weightx = 1.0;
			gridBagConstraints.insets = new Insets(5, 5, 5, 5);
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints7.gridy = 2;
			gridBagConstraints7.gridx = 0;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.ipadx = 148;
			gridBagConstraints3.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.gridwidth = 2;
			gridBagConstraints3.gridy = 5;
			jPanel3 = new JPanel();
			jPanel3.setLayout(new GridBagLayout());
			jPanel3.add(getJPanel4(), gridBagConstraints3);
			jPanel3.add(getJTextField(), gridBagConstraints);
			jPanel3.add(getJTextField1(), gridBagConstraints5);
			jPanel3.add(getJButton1(), gridBagConstraints6);
			jPanel3.add(getJButton(), gridBagConstraints14);
			jPanel3.add(jLabel11, gridBagConstraints21);
			jPanel3.add(jLabel12, gridBagConstraints31);
			jPanel3.add(getJScrollPane(), gridBagConstraints17);
		}
		return jPanel3;
	}
	
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.gridx = 0;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints4.gridy = 2;
			gridBagConstraints4.gridx = 3;
			jPanel4 = new JPanel();
			jPanel4.setLayout(new GridBagLayout());
		}
		return jPanel4;
	}
	
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setPreferredSize(new Dimension(200, 19));
		}
		return jTextField;
	}
	
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Hinzufügen");
			jButton.setPreferredSize(new Dimension(106, 19));
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						if (!isEntryConform(jTextField1.getText(), Peer.BLACKLIST_ENGINE_YACY)) {
							if (JOptionPane.showConfirmDialog(
									null,
									"Der Eintrag wird vom aktuell eingestellten Blacklist-Backend nicht " +
									"bearbeitet werden können! Trotzdem übernehmen?") > 0)
								return;
						}
					} catch (Exception ee) {
						if (JOptionPane.showConfirmDialog(
								null,
								"Das aktuell gewählte Blacklist-Backend wird nicht von yacy-admin unterstützt" +
								"und kann deshalb nicht auf Gültigkeit überprüft werden. Trotzdem übernehmen?") > 0)
							return;
					}
					
					if (jTextField1.getText().length() > 0 && jComboBox.getSelectedIndex() > -1) {
						try {
							peer.addToBlacklist(jTextField1.getText(), jComboBox.getSelectedItem().toString());
							list.addElement(jTextField1.getText());
						} catch (RemoteException ee) { cfg.log(ee); }
					}
				}
			});
		}
		return jButton;
	}
	
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
		}
		return jTextField1;
	}
	
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Suchen");
			jButton1.setPreferredSize(new Dimension(85, 19));
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (jComboBox.getSelectedIndex() == -1) return;
					if (jTextField.getText().length() == 0) {
						list.clear();
						try {
							for (String d : peer.getBlacklistsContents(false).get(jComboBox.getSelectedItem().toString())) {
								list.addElement(d);
							}
						} catch (RemoteException ee) { cfg.log(ee); }
					} else {
						int x = 0;
						String t = jTextField.getText();
						for (java.util.Enumeration d = list.elements(); d.hasMoreElements(); x++) {
							if (((String)d.nextElement()).indexOf(t) == -1)
								list.remove(x);
						}
					}
				}
			});
		}
		return jButton1;
	}
	
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("Löschen");
			jButton2.setPreferredSize(new Dimension(85, 19));
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						if (jComboBox.getSelectedIndex() > -1) { 
							peer.removeBlacklist(jComboBox.getSelectedItem().toString());
							jComboBox.removeItem(jComboBox.getSelectedItem());
						}
					} catch (RemoteException ee) { cfg.log(ee); }
				}
			});
		}
		return jButton2;
	}
	
	private JPanel getJPanel5() {
		if (jPanel5 == null) {
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.anchor = GridBagConstraints.WEST;
			gridBagConstraints16.gridx = -1;
			gridBagConstraints16.gridy = -1;
			gridBagConstraints16.insets = new Insets(5, 5, 5, 5);
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = 1;
			gridBagConstraints13.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints13.anchor = GridBagConstraints.WEST;
			gridBagConstraints13.gridy = 3;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 1;
			gridBagConstraints12.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints12.anchor = GridBagConstraints.WEST;
			gridBagConstraints12.gridy = 2;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 1;
			gridBagConstraints11.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints11.anchor = GridBagConstraints.WEST;
			gridBagConstraints11.gridy = 1;
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.gridx = 1;
			gridBagConstraints10.anchor = GridBagConstraints.WEST;
			gridBagConstraints10.gridy = 0;
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 0;
			gridBagConstraints9.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints9.gridy = 0;
			jLabel = new JLabel();
			jLabel.setText("Aktivieren für:");
			jPanel5 = new JPanel();
			jPanel5.setLayout(new GridBagLayout());
			jPanel5.setPreferredSize(new Dimension(200, 100));
			jPanel5.add(jLabel, gridBagConstraints9);
			jPanel5.add(getJCheckBox(), gridBagConstraints10);
			jPanel5.add(getJCheckBox1(), gridBagConstraints11);
			jPanel5.add(getJCheckBox2(), gridBagConstraints12);
			jPanel5.add(getJCheckBox3(), gridBagConstraints13);
		}
		return jPanel5;
	}
	
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("Crawler");
			jCheckBox.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						if (peer.getBlacklists().size() > 0 && jComboBox.getSelectedIndex() > -1) {
							peer.setBlacklistAttribute("crawler", jComboBox.getSelectedItem().toString());
						}
					} catch (RemoteException ee) { cfg.log(ee); }
				}
			});
		}
		return jCheckBox;
	}
	
	private JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new JCheckBox();
			jCheckBox1.setText("Proxy");
			jCheckBox1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						if (peer.getBlacklists().size() > 0 && jComboBox.getSelectedIndex() > -1) {
							peer.setBlacklistAttribute("proxy", jComboBox.getSelectedItem().toString());
						}
					} catch (RemoteException ee) { cfg.log(ee); }
				}
			});
		}
		return jCheckBox1;
	}
	
	private JCheckBox getJCheckBox2() {
		if (jCheckBox2 == null) {
			jCheckBox2 = new JCheckBox();
			jCheckBox2.setText("DHT");
			jCheckBox2.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						if (peer.getBlacklists().size() > 0 && jComboBox.getSelectedIndex() > -1) {
							peer.setBlacklistAttribute("dht", jComboBox.getSelectedItem().toString());
						}
					 } catch (RemoteException ee) { cfg.log(ee); }
				}
			});
		}
		return jCheckBox2;
	}
	
	private JCheckBox getJCheckBox3() {
		if (jCheckBox3 == null) {
			jCheckBox3 = new JCheckBox();
			jCheckBox3.setText("Suche");
			jCheckBox3.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					try {
						if (peer.getBlacklists().size() > 0 && jComboBox.getSelectedIndex() > -1) {
							peer.setBlacklistAttribute("search", jComboBox.getSelectedItem().toString());
						}
					} catch (RemoteException ee) { cfg.log(ee); }
				}
			});
		}
		return jCheckBox3;
	}
	
	private JPanel getJPanel62() {
		if (jPanel6 == null) {
			GridBagConstraints gridBagConstraints34 = new GridBagConstraints();
			gridBagConstraints34.gridx = 0;
			gridBagConstraints34.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints34.gridwidth = 2;
			gridBagConstraints34.gridy = 0;
			jLabel17 = new JLabel();
			jLabel17.setText("Blacklist Einträge laden");
			jLabel17.setFont(new Font("Dialog", Font.BOLD, 14));
			GridBagConstraints gridBagConstraints33 = new GridBagConstraints();
			gridBagConstraints33.gridx = 1;
			gridBagConstraints33.insets = new Insets(5, 0, 5, 5);
			gridBagConstraints33.gridy = 8;
			GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
			gridBagConstraints32.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints32.gridy = 8;
			gridBagConstraints32.weightx = 1.0;
			gridBagConstraints32.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints32.gridx = 0;
			GridBagConstraints gridBagConstraints30 = new GridBagConstraints();
			gridBagConstraints30.gridx = 0;
			gridBagConstraints30.anchor = GridBagConstraints.WEST;
			gridBagConstraints30.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints30.gridy = 7;
			jLabel16 = new JLabel();
			jLabel16.setText("Von Adblock-Liste");
			GridBagConstraints gridBagConstraints29 = new GridBagConstraints();
			gridBagConstraints29.gridx = 1;
			gridBagConstraints29.insets = new Insets(5, 0, 5, 5);
			gridBagConstraints29.gridy = 6;
			GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
			gridBagConstraints28.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints28.gridy = 6;
			gridBagConstraints28.weightx = 1.0;
			gridBagConstraints28.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints28.gridx = 0;
			GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
			gridBagConstraints27.gridx = 0;
			gridBagConstraints27.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints27.anchor = GridBagConstraints.WEST;
			gridBagConstraints27.gridy = 5;
			jLabel15 = new JLabel();
			jLabel15.setText("Von Datei");
			GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
			gridBagConstraints26.gridx = 1;
			gridBagConstraints26.insets = new Insets(5, 0, 5, 5);
			gridBagConstraints26.gridy = 4;
			GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
			gridBagConstraints25.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints25.gridy = 4;
			gridBagConstraints25.weightx = 1.0;
			gridBagConstraints25.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints25.gridx = 0;
			GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
			gridBagConstraints24.gridx = 0;
			gridBagConstraints24.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints24.anchor = GridBagConstraints.WEST;
			gridBagConstraints24.gridy = 3;
			jLabel14 = new JLabel();
			jLabel14.setText("Von URL");
			GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
			gridBagConstraints23.gridx = 1;
			gridBagConstraints23.insets = new Insets(5, 0, 5, 5);
			gridBagConstraints23.gridy = 2;
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints22.gridy = 2;
			gridBagConstraints22.weightx = 1.0;
			gridBagConstraints22.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints22.gridx = 0;
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.gridx = 0;
			gridBagConstraints15.anchor = GridBagConstraints.WEST;
			gridBagConstraints15.insets = new Insets(5, 5, 5, 5);
			gridBagConstraints15.gridy = 1;
			jLabel13 = new JLabel();
			jLabel13.setText("Von YaCy Peer");
			jPanel6 = new JPanel();
			jPanel6.setLayout(new GridBagLayout());
			jPanel6.add(jLabel13, gridBagConstraints15);
			jPanel6.add(getJTextField2(), gridBagConstraints22);
			jPanel6.add(getJButton3(), gridBagConstraints23);
			jPanel6.add(jLabel14, gridBagConstraints24);
			jPanel6.add(getJTextField3(), gridBagConstraints25);
			jPanel6.add(getJButton4(), gridBagConstraints26);
			jPanel6.add(jLabel15, gridBagConstraints27);
			jPanel6.add(getJTextField4(), gridBagConstraints28);
			jPanel6.add(getJButton5(), gridBagConstraints29);
			jPanel6.add(jLabel16, gridBagConstraints30);
			jPanel6.add(getJTextField5(), gridBagConstraints32);
			jPanel6.add(getJButton6(), gridBagConstraints33);
			jPanel6.add(jLabel17, gridBagConstraints34);
		}
		return jPanel6;
	}
	
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
		}
		return jTextField2;
	}
	
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText("Blacklist laden"); // Peer
			jButton3.setPreferredSize(new Dimension(125, 19));
			jButton3.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// jTextField2
				}
			});
		}
		return jButton3;
	}
	
	private JTextField getJTextField3() {
		if (jTextField3 == null) {
			jTextField3 = new JTextField();
		}
		return jTextField3;
	}
	
	private JButton getJButton4() {
		if (jButton4 == null) {
			jButton4 = new JButton();
			jButton4.setText("Blacklist laden"); // URL
			jButton4.setPreferredSize(new Dimension(125, 19));
			jButton4.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// jTextField3
				}
			});
		}
		return jButton4;
	}
	
	private JTextField getJTextField4() {
		if (jTextField4 == null) {
			jTextField4 = new JTextField();
		}
		return jTextField4;
	}
	
	private JButton getJButton5() {
		if (jButton5 == null) {
			jButton5 = new JButton();
			jButton5.setText("Blacklist laden"); //Datei
			jButton5.setPreferredSize(new Dimension(125, 19));
			jButton5.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// jTextField4
				}
			});
		}
		return jButton5;
	}
	
	private JTextField getJTextField5() {
		if (jTextField5 == null) {
			jTextField5 = new JTextField();
		}
		return jTextField5;
	}
	
	private JButton getJButton6() {
		if (jButton6 == null) {
			jButton6 = new JButton();
			jButton6.setText("Blacklist laden"); // Adblock
			jButton6.setPreferredSize(new Dimension(125, 19));
			jButton6.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// jTextField5
				}
			});
		}
		return jButton6;
	}
	
	private JTextField getJTextField6() {
		if (jTextField6 == null) {
			jTextField6 = new JTextField();
		}
		return jTextField6;
	}
	
	private JButton getJButton7() {
		if (jButton7 == null) {
			jButton7 = new JButton();
			jButton7.setText("Neu...");
			jButton7.setPreferredSize(new Dimension(67, 19));
			jButton7.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (jTextField6.getText().length() == 0) return;
					try {
						peer.addBlacklist(
								jTextField6.getText(),
								true,
								peer.getBlacklistTypes());
						jComboBox.addItem(jTextField6.getText());
						jComboBox.setSelectedItem(jTextField6.getText());
						jTextField6.setText("");
					} catch (PBlacklistExistsEx ee) {
						JOptionPane.showMessageDialog(
								null,
								"Es existiert bereits eine Blacklist mit diesem Namen!",
								"Blacklist existiert",
								JOptionPane.ERROR_MESSAGE);
					} catch (RemoteException ee) {
						cfg.log(ee);
					}
				}
			});
		}
		return jButton7;
	}
	
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJList());
		}
		return jScrollPane;
	}
	
	private JList getJList() {
		if (jList == null) {
			list = new DefaultListModel();
			list.clear();
			jList = new JList(list);
			jList.add(getPopup());
			jList.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					if (e.getButton() == MouseEvent.BUTTON3) {	// rechte Maustaste
						jPopupMenu.getComponent(0).setVisible(jList.getSelectedIndices().length == 1);
						if (jList.getSelectedIndices().length > 0) {
							jPopupMenu.show(jList, e.getX(), e.getY());
						}
					}
				}
			});
		}
		return jList;
	}
	
	private JPopupMenu getPopup() {
		if (jPopupMenu == null) {
			jPopupMenu = new JPopupMenu();
			JMenuItem pmi1 = new JMenuItem("Bearbeiten");
			pmi1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// TODO: Dialog: Bearbeiten
				}
			});
			jPopupMenu.add(pmi1);
			JMenuItem pmi2 = new JMenuItem("Löschen");
			pmi2.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// XXX: Abfrage ob "wirklich"?
					getJDialog().setVisible(true);
				}
			});
			jPopupMenu.add(pmi2);
		}
		return jPopupMenu;
	}
	
	private JDialog getJDialog() {
		if (jDialog == null) {
			jDialog = new JDialog();
			jDialog.setModal(true);
			jDialog.setSize(new Dimension(296, 133));
			jDialog.setTitle("Bestätigung");
			jDialog.setContentPane(getJContentPane());
		}
		return jDialog;
	}
	
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.gridx = 0;
			gridBagConstraints19.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints19.insets = new Insets(20, 0, 0, 0);
			gridBagConstraints19.gridy = 3;
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.gridx = 0;
			gridBagConstraints18.gridy = 2;
			jLabel3 = new JLabel();
			jLabel3.setText("wirklich löschen?");
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 0;
			gridBagConstraints8.gridy = 0;
			jLabel2 = new JLabel();
			jLabel2.setText("Möchten Sie die gewählten Einträge");
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridheight = -1;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.ipadx = 282;
			gridBagConstraints2.gridx = 0;
			jLabel1 = new JLabel();
			jLabel1.setText("");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jLabel1, gridBagConstraints2);
			jContentPane.add(jLabel2, gridBagConstraints8);
			jContentPane.add(jLabel3, gridBagConstraints18);
			jContentPane.add(getJPanel7(), gridBagConstraints19);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel7() {
		if (jPanel7 == null) {
			jPanel7 = new JPanel();
			jPanel7.setLayout(new BorderLayout());
			jPanel7.setMinimumSize(new Dimension(200, 30));
			jPanel7.setPreferredSize(new Dimension(270, 24));
			jPanel7.add(getJButton8(), BorderLayout.EAST);
			jPanel7.add(getJButton9(), BorderLayout.WEST);
		}
		return jPanel7;
	}
	
	private JButton getJButton8() {
		if (jButton8 == null) {
			jButton8 = new JButton();
			jButton8.setText("Löschen");
			jButton8.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					for (Object d : jList.getSelectedValues()) {
						try {
							peer.removeBlacklistItem(d.toString(), jComboBox.getSelectedItem().toString());
							list.removeElement(d);
						} catch (RemoteException ee) { cfg.log(ee); }
					}
					jDialog.setVisible(false);
				}
			});
		}
		return jButton8;
	}
	
	private JButton getJButton9() {
		if (jButton9 == null) {
			jButton9 = new JButton();
			jButton9.setText("Abbrechen");
			jButton9.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jDialog.setVisible(false);
				}
			});
		}
		return jButton9;
	}
	
}
