/* 
 * Autor: Franz Brauße
 * License: GPL v2 
 */

package yacy.datatypes;
	
public final class QueueEntry {
	
	private String 	initiator 	= null;
	private int 	depth 		= 0;
	private String 	modified 	= null;
	private String 	anchor 		= null;
	private String 	url 		= null;
	private long 	size 		= 0;
	private String 	hash 		= null;
	private boolean inProcess 	= false;
	
	public QueueEntry(
			String initiator,
			int depth,
			String modified,
			String anchor,
			String url,
			long size,
			String hash,
			boolean inProcess) {
		this.initiator = initiator;
		this.depth = depth;
		this.modified = modified;
		this.anchor = anchor;
		this.url = url;
		this.size = size;
		this.hash = hash;
		this.inProcess = inProcess;
	}
	
	public String 	getInitiator() 	{ return this.initiator; }
	public int 		getDepth() 		{ return this.depth; }
	public String 	getModified() 	{ return this.modified; }
	public String 	getAnchor() 	{ return this.anchor; }
	public String 	getURL() 		{ return this.url; }
	public long 	getSize() 		{ return this.size; }
	public String 	getHash() 		{ return this.hash; }
	public boolean 	isInProcess() 	{ return this.inProcess; }
}
