/* 
 * Autor: Franz Brauße
 * License: GPL v2 
 */

package yacy.event;

public class PeerTransferFinishedEvent extends PeerEvent {
	
	private String 	fileLocalPath 	= null;
	private String 	fileRemotePath 	= null;
	private boolean wasUpload 		= false;
	private long	durationms		= 0L;
	private String	fileComment		= null;
	private boolean wasIndexed		= false;
	
	public PeerTransferFinishedEvent(
			String fileLocalPath,
			String fileRemotePath,
			boolean wasUpload,
			long durationms,
			String fileComment,
			boolean wasIndexed) {
		this.fileLocalPath = fileLocalPath;
		this.fileRemotePath = fileRemotePath;
		this.wasUpload = wasUpload;
		this.durationms = durationms;
		this.fileComment = fileComment;
		this.wasIndexed = wasIndexed;
	}
	
	public String 	getFileLocalPath() 	{ return this.fileLocalPath; }
	public String 	getFileRemotePath() { return this.fileRemotePath; }
	public long		getDurationMS()		{ return this.durationms; }
	public boolean 	wasUpload() 		{ return this.wasUpload; }
	public boolean 	wasDownload() 		{ return !this.wasUpload; }
	public String 	getFileComment()	{ return this.fileComment; }
	public boolean 	wasIndexed()		{ return this.wasIndexed; }
}
