/* 
 * Autor: Franz Brauße
 * License: GPL v2 
 */

package yacy.exceptions;

public class PSVNRevisionTooLowEx extends PeerException {
	
	private static final long serialVersionUID = 1L;
	
	private static final String exMsg = "Peer uses too low SVN Revision of YaCy: ";
	
	private int revision = 0;
	private int neededRevision = 0;
	
	public PSVNRevisionTooLowEx(int SVNRevision, int neededRevision) {
		super(exMsg + SVNRevision);
		this.revision = SVNRevision;
		this.neededRevision = neededRevision;
	}
	
	public int getPeerRevision() { return this.revision; }
	public int getNeededRevision() { return this.neededRevision; }
}
